#include <pthread.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include <stdlib.h>

#define NUMBER_OF_THREADS (3)
#define CHARACTER_BUFFER_LENGTH (64)
#define MAX_THREAD_NAME_LENGTH (CHARACTER_BUFFER_LENGTH + 1)
#define SLEEP_PERIOD (1)
#define MS_PER_SECOND (1000)
#define SLEEP_PERIOD_IN_MS (SLEEP_PERIOD * MS_PER_SECOND)
#define SLEEP_PERIOD_IN_US (SLEEP_PERIOD_IN_MS * 1000)

static const char *messages[]={"One", "Two", "Three"};
void *thread1(void *param);
void *thread2(void *param);
void *thread3(void *param);

bool continueRunning = true;  // Global variable which determines if 
                              // program should continue.

char message[255];            // User input into program.
char messageCopy[255];

int main(int argc, char* argv[])
{
  pthread_t tids[NUMBER_OF_THREADS];
  pthread_attr_t attr[NUMBER_OF_THREADS];
  int index;

  pthread_attr_init(&attr[0]);
    /* Create the thread. */
  pthread_create(&tids[0], &attr[0], thread1, (void*)messages[0]);   

  pthread_attr_init(&attr[1]);
    /* Create the thread. */
  pthread_create(&tids[1], &attr[1], thread2, (void*)messages[1]);   


  pthread_attr_init(&attr[2]);
    /* Create the thread. */
  pthread_create(&tids[2], &attr[2], thread3, (void*)messages[2]);   

  for (index = 0;index < 1; index++)
  {
    pthread_join(tids[index], NULL);
  }
  
  return 0;
}

void *thread1(void *parameter)
{
  char* msg = &message[0];
  while (continueRunning==true)
  {  
    printf("Enter a message.\n");
    msg = gets(&message[0]); // Read the message from the keyboard.
    strcpy(&messageCopy[0], &message[0]);  // Copy the message to the other buffer.
    if (strcmp(&message[0], "QUIT")==0)
    {
      continueRunning=false;
      exit(0);
    }
  }
}

void *thread2(void * parameter)
{
  int count=5;
  int index=0;
  char threadName[MAX_THREAD_NAME_LENGTH];

  strcpy(threadName, (char*)parameter);

  while (continueRunning == true)
  {
    printf("%s: %d\n", threadName, index);
    if (strlen(&message[0])>0)
    {
      printf("Message received: %s\n", &message[0]);
      message[0] = 0;
    }
    usleep(SLEEP_PERIOD_IN_US);
    index++;
  }
  printf("Thread %s exiting\n", threadName);
}

void *thread3(void * parameter)
{
  int minutes = 0;
  int seconds = 0;
  int count=5;
  char threadName[MAX_THREAD_NAME_LENGTH];

  strcpy(threadName, (char*)parameter);

  while (continueRunning == true)
  {
	usleep(SLEEP_PERIOD_IN_US);
	seconds++;
	
	if (seconds == 60)
	{
	  seconds = 0;
	  minutes++;
	}
	printf("%d:%d\n", minutes, seconds);

  }
  printf("Thread %s exiting\n", threadName);
}
